Index: /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfcavgam.F90
===================================================================
--- /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfcavgam.F90	(revision 12076)
+++ /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfcavgam.F90	(revision 12077)
@@ -10,5 +10,5 @@
    !!   isfcav_gammats       : compute exchange coeficient gamma 
    !!----------------------------------------------------------------------
-   USE isf
+   USE isf_oce
    USE isfutils, ONLY: debug
    USE isftbl  , ONLY: isf_tbl
@@ -46,5 +46,5 @@
       !!
       !! ** Method     : select the gamma formulation
-      !!                 3 method available (cst, AD15 and HJ99)
+      !!                 3 method available (cst, vel and vel_stab)
       !!---------------------------------------------------------------------
       !!-------------------------- OUT -------------------------------------
@@ -66,5 +66,5 @@
          ! gamma is constant (specified in namelist)
          ! nothing to do
-      CASE ('ad15', 'hj99')
+      CASE ('vel', 'vel_stab')
          ! compute velocity in tbl
          CALL isf_tbl(Kmm, uu(:,:,:,Kmm) ,zutbl(:,:),'U', miku, rhisf_tbl_cav)
@@ -90,8 +90,8 @@
          pgt(:,:) = rn_gammat0
          pgs(:,:) = rn_gammas0
-      CASE ( 'ad15' ) ! gamma is proportional to u*
-         CALL gammats_AD15 (                   zutbl, zvtbl, rCd0_top, r_ke0_top,               pgt, pgs )
-      CASE ( 'hj99' ) ! gamma depends of stability of boundary layer and u*
-         CALL gammats_HJ99 (Kmm, pttbl, pstbl, zutbl, zvtbl, rCd0_top, r_ke0_top, pqoce, pqfwf, pgt, pgs )
+      CASE ( 'vel' ) ! gamma is proportional to u*
+         CALL gammats_vel      (                   zutbl, zvtbl, rCd0_top, r_ke0_top,               pgt, pgs )
+      CASE ( 'vel_stab' ) ! gamma depends of stability of boundary layer and u*
+         CALL gammats_vel_stab (Kmm, pttbl, pstbl, zutbl, zvtbl, rCd0_top, r_ke0_top, pqoce, pqfwf, pgt, pgs )
       CASE DEFAULT
          CALL ctl_stop('STOP','method to compute gamma (cn_gammablk) is unknown (should not see this)')
@@ -116,5 +116,5 @@
    !!-----------------------------------------------------------------------------------------------------
    !
-   SUBROUTINE gammats_AD15(putbl, pvtbl, pCd, pke2, &   ! <<== in
+   SUBROUTINE gammats_vel( putbl, pvtbl, pCd, pke2, &   ! <<== in
       &                                  pgt, pgs   )   ! ==>> out gammats [m/s]
       !!----------------------------------------------------------------------
@@ -123,6 +123,5 @@
       !! ** Method     : gamma is velocity dependent ( gt= gt0 * Ustar )
       !!
-      !! ** Reference  : Jenkins et al., 2010, JPO, p2298-2312
-      !!                 Asay-Davis et al., Geosci. Model Dev., 9, 2471-2497, 2016
+      !! ** Reference  : Asay-Davis et al., Geosci. Model Dev., 9, 2471-2497, 2016
       !!---------------------------------------------------------------------
       !!-------------------------- OUT -------------------------------------
@@ -146,8 +145,8 @@
       CALL iom_put('isfustar',zustar(:,:))
       !
-   END SUBROUTINE gammats_AD15
-
-   SUBROUTINE gammats_HJ99( Kmm, pttbl, pstbl, putbl, pvtbl, pCd, pke2, pqoce, pqfwf, &  ! <<== in
-      &                                                                 pgt  , pgs    )  ! ==>> out gammats [m/s]
+   END SUBROUTINE gammats_vel
+
+   SUBROUTINE gammats_vel_stab( Kmm, pttbl, pstbl, putbl, pvtbl, pCd, pke2, pqoce, pqfwf, &  ! <<== in
+      &                                                                     pgt  , pgs    )  ! ==>> out gammats [m/s]
       !!----------------------------------------------------------------------
       !! ** Purpose    : compute the coefficient echange coefficient 
@@ -186,5 +185,5 @@
       !
       ! compute ustar
-      zustar(:,:) = SQRT( pCd * ( putbl(:,:) * putbl(:,:) + pvtbl(:,:) * pvtbl(:,:) + r_ke0_top ) )
+      zustar(:,:) = SQRT( pCd * ( putbl(:,:) * putbl(:,:) + pvtbl(:,:) * pvtbl(:,:) + pke2 ) )
       !
       ! output ustar
@@ -254,5 +253,5 @@
       END DO
 
-   END SUBROUTINE gammats_HJ99
+   END SUBROUTINE gammats_vel_stab
 
 END MODULE isfcavgam
Index: /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfcavmlt.F90
===================================================================
--- /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfcavmlt.F90	(revision 12076)
+++ /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfcavmlt.F90	(revision 12077)
@@ -12,5 +12,5 @@
    !!----------------------------------------------------------------------
 
-   USE isf                      ! ice shelf
+   USE isf_oce                  ! ice shelf
    USE isftbl , ONLY: isf_tbl   ! ice shelf depth average
    USE isfutils,ONLY: debug     ! debug subroutine
@@ -77,7 +77,7 @@
       !
       IF (ln_isfdebug) THEN
-         CALL debug( 'isfcav_mlt:', pqhc (:,:) )
-         CALL debug( 'isfcav_mlt:', pqoce(:,:) )
-         CALL debug( 'isfcav_mlt:', pqfwf(:,:) )
+         CALL debug( 'isfcav_mlt qhc  :', pqhc (:,:) )
+         CALL debug( 'isfcav_mlt qoce :', pqoce(:,:) )
+         CALL debug( 'isfcav_mlt qfwf :', pqfwf(:,:) )
       END IF
       !
Index: /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfcpl.F90
===================================================================
--- /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfcpl.F90	(revision 12076)
+++ /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfcpl.F90	(revision 12077)
@@ -12,5 +12,5 @@
    !!   isfrst : read/write iceshelf variables in/from restart
    !!----------------------------------------------------------------------
-   USE isf                              ! ice shelf variable
+   USE isf_oce                          ! ice shelf variable
    USE isfutils, ONLY : debug
    USE lib_mpp , ONLY: mpp_sum, mpp_max ! mpp routine
@@ -25,6 +25,6 @@
    PRIVATE
 
-   PUBLIC isfcpl_rst_write, isfcpl_init  ! iceshelf restart read and write 
-   PUBLIC isfcpl_ssh, isfcpl_tra, isfcpl_vol, isfcpl_cons
+   PUBLIC isfcpl_rst_write, isfcpl_init                    ! iceshelf restart read and write 
+   PUBLIC isfcpl_ssh, isfcpl_tra, isfcpl_vol, isfcpl_cons  ! iceshelf correction for ssh, tra, dyn and conservation 
 
    TYPE isfcons
@@ -48,4 +48,13 @@
    SUBROUTINE isfcpl_init(Kbb, Kmm, Kaa)
       !!---------------------------------------------------------------------
+      !!                   ***  ROUTINE iscpl_init  ***
+      !! 
+      !! ** Purpose : correct ocean state for new wet cell and horizontal divergence 
+      !!              correction for the dynamical adjustement
+      !!
+      !! ** Action : - compute ssh on new wet cell
+      !!             - compute T/S on new wet cell
+      !!             - compute horizontal divergence correction as a volume flux
+      !!             - compute the T/S/vol correction increment to keep trend to 0
       !!
       !!---------------------------------------------------------------------
@@ -480,5 +489,5 @@
       INTEGER  ::   jisf                              ! start, end and current position in the increment array
       INTEGER  ::   ingb, ifind                       ! 0/1 target found or need to be found 
-      INTEGER  ::   ingb, ifind, nisfl_area           ! global number of cell concerned by the wet->dry case 
+      INTEGER  ::   nisfl_area                        ! global number of cell concerned by the wet->dry case 
       INTEGER, DIMENSION(jpnij) :: nisfl              ! local  number of cell concerned by the wet->dry case
       !
Index: /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfdiags.F90
===================================================================
--- /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfdiags.F90	(revision 12076)
+++ /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfdiags.F90	(revision 12077)
@@ -1,7 +1,6 @@
 MODULE isfdiags
    !!======================================================================
-   !!                       ***  MODULE  sbcisf  ***
-   !! Surface module :  update surface ocean boundary condition under ice
-   !!                   shelf
+   !!                       ***  MODULE  isfdiags  ***
+   !! ice shelf diagnostics module :  manage the 2d and 3d flux outputs from the ice shelf module
    !!======================================================================
    !! History :  3.2  !  2011-02  (C.Harris  ) Original code isf cav
@@ -16,6 +15,5 @@
    USE in_out_manager ! I/O manager
    USE dom_oce
-   USE isf            ! ice shelf variable
-   USE isfutils
+   USE isf_oce        ! ice shelf variable
    USE iom            ! 
 
@@ -38,5 +36,6 @@
       !!                  ***  ROUTINE isf_diags_flx ***
       !!
-      !! ** Purpose : 
+      !! ** Purpose : manage the 2d and 3d flux outputs of the ice shelf module
+      !!              fwf, latent heat flux, heat content flux, oce->ice heat flux
       !!
       !!----------------------------------------------------------------------
@@ -59,9 +58,9 @@
       cvarqhc  = 'qhcisf_'//cdisf  ; cvarqhc3d  = 'qhcisf3d_'//cdisf
       !
-      ! output 2d melt rate, latent heat and heat content flux
-      CALL iom_put( TRIM(cvarqfwf), pqfwf(:,:) )   ! isf mass flux (opposite sign)
-      CALL iom_put( TRIM(cvarqoce), pqoce(:,:) )   ! isf oce to ice   flux  (cpo*gt*dt)
-      CALL iom_put( TRIM(cvarqlat), pqlat(:,:) )   ! isf oce to ice   flux  (cpo*gt*dt)
-      CALL iom_put( TRIM(cvarqhc) , pqhc (:,:) )   ! isf heat content flux  (cpo*fwf*Tfrz)
+      ! output 2d melt rate, latent heat and heat content flux from the injected water
+      CALL iom_put( TRIM(cvarqfwf), pqfwf(:,:) )   ! mass         flux ( >0 out )
+      CALL iom_put( TRIM(cvarqoce), pqoce(:,:) )   ! oce to ice   flux ( >0 out )
+      CALL iom_put( TRIM(cvarqlat), pqlat(:,:) )   ! latent heat  flux ( >0 out )
+      CALL iom_put( TRIM(cvarqhc) , pqhc (:,:) )   ! heat content flux ( >0 out )
       !
       ! output 3d Diagnostics
@@ -77,5 +76,6 @@
       !!                  ***  ROUTINE isf_diags_2dto3d ***
       !!
-      !! ** Purpose : 
+      !! ** Purpose : compute the 3d flux outputs as they are injected into NEMO 
+      !!              (ie uniformaly spread into the top boundary layer or parametrisation layer)
       !!
       !!----------------------------------------------------------------------
Index: /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfdynatf.F90
===================================================================
--- /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfdynatf.F90	(revision 12076)
+++ /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfdynatf.F90	(revision 12077)
@@ -11,5 +11,5 @@
    !!-------------------------------------------------------------------------
 
-   USE isf
+   USE isf_oce
 
    USE phycst , ONLY: r1_rau0         ! physical constant
Index: /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfhdiv.F90
===================================================================
--- /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfhdiv.F90	(revision 12076)
+++ /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfhdiv.F90	(revision 12077)
@@ -1,6 +1,18 @@
 MODULE isfhdiv
+   !!======================================================================
+   !!                       ***  MODULE  isfhdiv  ***
+   !! ice shelf horizontal divergence module :  update the horizontal divergence
+   !!                   with the ice shelf melt and coupling correction
+   !!======================================================================
+   !! History :  4.0  !  2019-09  (P. Mathiot) Original code
+   !!----------------------------------------------------------------------
 
-   USE isf                    ! ice shelf
-   USE isfutils 
+   !!----------------------------------------------------------------------
+   !!   isf_hdiv    : update the horizontal divergence with the ice shelf 
+   !!                 melt and coupling correction
+   !!----------------------------------------------------------------------
+
+   USE isf_oce                ! ice shelf
+
    USE dom_oce                ! time and space domain
    USE phycst , ONLY: r1_rau0 ! physical constant
@@ -40,5 +52,8 @@
          IF ( ln_isfcpl .AND. kt /= 0 ) THEN
             !
-            ! correct divergence only for the first time step
+            ! Dynamical stability at start up after change in under ice shelf cavity geometry is achieve by correcting the divergence.
+            ! This is achieved by applying a volume flux in order to keep the horizontal divergence after remapping 
+            ! the same as at the end of the latest time step. So correction need to be apply at nit000 (euler time step) and
+            ! half of it at nit000+1 (leap frog time step).
             IF ( kt == nit000   ) CALL isf_hdiv_cpl(Kmm, risfcpl_vol       , phdiv)
             IF ( kt == nit000+1 ) CALL isf_hdiv_cpl(Kmm, risfcpl_vol*0.5_wp, phdiv)
Index: /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfload.F90
===================================================================
--- /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfload.F90	(revision 12076)
+++ /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfload.F90	(revision 12077)
@@ -11,11 +11,11 @@
    !!----------------------------------------------------------------------
 
-   USE isf, ONLY: cn_isfload   ! ice shelf variables
+   USE isf_oce, ONLY: cn_isfload, rn_isfload_T, rn_isfload_S ! ice shelf variables
 
    USE dom_oce, ONLY: e3w, gdept, risfdep, mikt     ! vertical scale factor
    USE eosbn2 , ONLY: eos                           ! eos routine
 
-   USE lib_mpp, ONLY: ctl_stop ! ctl_stop routine
-   USE in_out_manager  ! 
+   USE lib_mpp, ONLY: ctl_stop                               ! ctl_stop routine
+   USE in_out_manager                                        ! 
 
    IMPLICIT NONE
@@ -45,6 +45,6 @@
       ! ice shelf cavity
       SELECT CASE ( cn_isfload )
-      CASE ( 'isomip' )
-         CALL isf_load_isomip ( Kmm, pisfload )
+      CASE ( 'uniform' )
+         CALL isf_load_uniform ( Kmm, pisfload )
       CASE DEFAULT
          CALL ctl_stop('STOP','method cn_isfload to compute ice shelf load does not exist (isomip), check your namelist')
@@ -53,5 +53,5 @@
    END SUBROUTINE isf_load
 
-   SUBROUTINE isf_load_isomip( Kmm, pisfload )
+   SUBROUTINE isf_load_uniform( Kmm, pisfload )
       !!--------------------------------------------------------------------
       !!                  ***  SUBROUTINE isf_load  ***
@@ -79,6 +79,6 @@
       znad = 1._wp                     !- To use density and not density anomaly
       !
-      !                                !- assume water displaced by the ice shelf is at T=-1.9 and S=34.4 (rude)
-      zts_top(:,:,jp_tem) = -1.9_wp   ;   zts_top(:,:,jp_sal) = 34.4_wp
+      !                                !- assume water displaced by the ice shelf is at T=rn_isfload_T and S=rn_isfload_S (rude)
+      zts_top(:,:,jp_tem) = rn_isfload_T   ;   zts_top(:,:,jp_sal) = rn_isfload_S
       !
       DO jk = 1, jpk                   !- compute density of the water displaced by the ice shelf 
@@ -113,5 +113,5 @@
       END DO
       !
-   END SUBROUTINE isf_load_isomip
+   END SUBROUTINE isf_load_uniform
 
 END MODULE isfload
Index: /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfpar.F90
===================================================================
--- /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfpar.F90	(revision 12076)
+++ /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfpar.F90	(revision 12077)
@@ -14,11 +14,11 @@
    !!   isfpar       : compute ice shelf melt using a prametrisation of ice shelf cavities
    !!----------------------------------------------------------------------
-   USE isf            ! ice shelf
+   USE isf_oce        ! ice shelf
    !
    USE isfrst   , ONLY: isfrst_write, isfrst_read ! ice shelf restart read/write subroutine
    USE isftbl   , ONLY: isf_tbl_ktop, isf_tbl_lvl ! ice shelf top boundary layer properties subroutine
+   USE isfparmlt, ONLY: isfpar_mlt                ! ice shelf melt formulation subroutine
+   USE isfdiags , ONLY: isf_diags_flx             ! ice shelf diags subroutine
    USE isfutils , ONLY: debug, read_2dcstdta      ! ice shelf debug subroutine
-   USE isfparmlt, ONLY: isfpar_mlt     ! ice shelf melt formulation subroutine
-   USE isfdiags , ONLY: isf_diags_flx  ! ice shelf diags subroutine
    !
    USE dom_oce  , ONLY: bathy          ! ocean space and time domain
@@ -48,4 +48,11 @@
       !!
       !! ** Purpose : compute the heat and fresh water due to ice shelf melting/freezing using a parametrisation 
+      !!
+      !! ** Comment : in isf_par and all its call tree, 
+      !!              'tbl' means parametrisation layer (ie how the far field temperature/salinity is computed) 
+      !!              instead of in a proper top boundary layer as at the ice shelf ocean interface
+      !!              as the action to compute the properties of the tbl or the parametrisation layer are the same,
+      !!              (ie average T/S over a specific depth (can be across multiple levels))
+      !!              the name tbl was kept.
       !!
       !!---------------------------------------------------------------------
Index: /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfparmlt.F90
===================================================================
--- /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfparmlt.F90	(revision 12076)
+++ /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfparmlt.F90	(revision 12077)
@@ -8,5 +8,5 @@
    !!----------------------------------------------------------------------
 
-   USE isf            ! ice shelf
+   USE isf_oce                  ! ice shelf
    USE isftbl , ONLY: isf_tbl   ! ice shelf depth average
 
Index: /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfstp.F90
===================================================================
--- /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfstp.F90	(revision 12076)
+++ /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfstp.F90	(revision 12077)
@@ -14,5 +14,5 @@
    !!----------------------------------------------------------------------
    !
-   USE isf            ! isf variables
+   USE isf_oce                                      ! isf variables
    USE isfload, ONLY: isf_load                      ! ice shelf load
    USE isftbl , ONLY: isf_tbl_lvl                   ! ice shelf boundary layer
@@ -187,12 +187,12 @@
             WRITE(numout,*) '      melt inside the cavity                  ln_isfcav_mlt   = ', ln_isfcav_mlt
             IF ( ln_isfcav_mlt) THEN
-               WRITE(numout,*) '         melt formulation                        cn_isfcav_mlt   = ', TRIM(cn_isfcav_mlt)
-               WRITE(numout,*) '         thickness of the top boundary layer     rn_htbl     = ', rn_htbl
-               WRITE(numout,*) '         gamma formulation                       cn_gammablk = ', TRIM(cn_gammablk) 
+               WRITE(numout,*) '         melt formulation                         cn_isfcav_mlt= ', TRIM(cn_isfcav_mlt)
+               WRITE(numout,*) '         thickness of the top boundary layer      rn_htbl      = ', rn_htbl
+               WRITE(numout,*) '         gamma formulation                        cn_gammablk  = ', TRIM(cn_gammablk) 
                IF ( TRIM(cn_gammablk) .NE. 'spe' ) THEN 
-                  WRITE(numout,*) '         gammat coefficient                       rn_gammat0  = ', rn_gammat0  
-                  WRITE(numout,*) '         gammas coefficient                       rn_gammas0  = ', rn_gammas0  
-                  WRITE(numout,*) '         top drag coef.    used (from namdrg_top) rn_Cd0      = ', r_Cdmin_top
-                  WRITE(numout,*) '         top background ke used (from namdrg_top) rn_ke0      = ', r_ke0_top
+                  WRITE(numout,*) '         gammat coefficient                       rn_gammat0   = ', rn_gammat0  
+                  WRITE(numout,*) '         gammas coefficient                       rn_gammas0   = ', rn_gammas0  
+                  WRITE(numout,*) '         top background ke used (from namdrg_top) rn_ke0       = ', r_ke0_top
+                  WRITE(numout,*) '         top drag coef.    used (from namdrg_top) rn_Cd0       = ', r_Cdmin_top
                END IF
             END IF
@@ -222,6 +222,11 @@
          END IF
 
-         IF (ln_isfcav) WRITE(numout,*) '      Ice shelf load method                   cn_isfload        = ', TRIM(cn_isfload)
+         IF (ln_isfcav) THEN
+            WRITE(numout,*) '      Ice shelf load method                   cn_isfload        = ', TRIM(cn_isfload)
+            WRITE(numout,*) '         Temperature used to compute the ice shelf load            = ', rn_isfload_T
+            WRITE(numout,*) '         Salinity    used to compute the ice shelf load            = ', rn_isfload_S
+         END IF
          WRITE(numout,*) ''
+         FLUSH(numout)
 
       END IF
@@ -245,5 +250,5 @@
       IF ( l_isfoasis .AND. ln_isf ) THEN
          !
-         CALL ctl_stop( ' OASIS and ice shelf not tested' )
+         CALL ctl_stop( ' ln_ctl and ice shelf not tested' )
          !
          ! NEMO coupled to ATMO model with isf cavity need oasis method for melt computation 
@@ -277,9 +282,11 @@
       INTEGER               :: ios                  ! Local integer output status for namelist read
       !!----------------------------------------------------------------------
-      NAMELIST/namisf/ ln_isf       ,                                                                               & 
-         &             ln_isfcav_mlt, cn_isfcav_mlt, cn_gammablk, rn_gammat0, rn_gammas0, rn_htbl, sn_isfcav_fwf,   &
-         &             ln_isfpar_mlt, cn_isfpar_mlt, sn_isfpar_fwf, sn_isfpar_zmin, sn_isfpar_zmax, sn_isfpar_Leff, &
-         &             ln_isfcpl    , nn_drown, ln_isfcpl_cons, ln_isfdebug,                                        &
-         &             cn_isfload   , cn_isfdir
+      NAMELIST/namisf/ ln_isf        ,                                                           & 
+         &             cn_gammablk   , rn_gammat0    , rn_gammas0    , rn_htbl, sn_isfcav_fwf,   &
+         &             ln_isfcav_mlt , cn_isfcav_mlt , sn_isfcav_fwf ,                           &
+         &             ln_isfpar_mlt , cn_isfpar_mlt , sn_isfpar_fwf ,                           &
+         &             sn_isfpar_zmin, sn_isfpar_zmax, sn_isfpar_Leff,                           &
+         &             ln_isfcpl     , nn_drown      , ln_isfcpl_cons, ln_isfdebug,              &
+         &             cn_isfload    , rn_isfload_T  , rn_isfload_S  , cn_isfdir
       !!----------------------------------------------------------------------
       !
Index: /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isftbl.F90
===================================================================
--- /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isftbl.F90	(revision 12076)
+++ /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isftbl.F90	(revision 12077)
@@ -14,5 +14,5 @@
    !!----------------------------------------------------------------------
 
-   USE isf     ! ice shelf variables
+   USE isf_oce ! ice shelf variables
 
    USE dom_oce ! vertical scale factor and depth
Index: /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfutils.F90
===================================================================
--- /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfutils.F90	(revision 12076)
+++ /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/ISF/isfutils.F90	(revision 12077)
@@ -15,5 +15,7 @@
    USE lib_fortran   , ONLY: glob_sum, glob_min, glob_max             ! compute global value
    USE par_oce       , ONLY: jpi,jpj,jpk                              ! domain size
-   USE in_out_manager, ONLY: wp, lwp, numout                          ! miscelenious
+   USE dom_oce       , ONLY: nldi, nlei, nldj, nlej                   ! local domain
+   USE in_out_manager, ONLY: i8, wp, lwp, numout                          ! miscelenious
+   USE lib_mpp
 
    IMPLICIT NONE
@@ -54,20 +56,39 @@
       !!                  ***  ROUTINE isf_debug2d  ***
       !!
-      !! ** Purpose : add debug print
+      !! ** Purpose : add debug print for 2d variables
       !!
       !!-------------------------- IN  -------------------------------------
-      CHARACTER(LEN=256)          , INTENT(in   ) :: cdtxt
+      CHARACTER(LEN=*)            , INTENT(in   ) :: cdtxt
       REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) :: pvar
       !!--------------------------------------------------------------------
-      REAL(wp) :: zmin, zmax, zsum
+      REAL(wp)    :: zmin, zmax, zsum
+      INTEGER(i8) :: imodd, ip
+      INTEGER     :: itmps,imods, ji, jj, jk
       !!--------------------------------------------------------------------
       !
+      ! global min/max/sum to check data range and NaN
       zsum = glob_sum( 'debug', pvar(:,:) )
       zmin = glob_min( 'debug', pvar(:,:) )
       zmax = glob_max( 'debug', pvar(:,:) )
       !
-      IF (lwp) WRITE(numout,*) TRIM(cdtxt),' (min, max, sum) : ',zmin, zmax, zsum
+      ! basic check sum to check reproducibility
+      ! TRANSFER function find out the integer corresponding to pvar(i,j) bit pattern
+      ! MOD allow us to keep only the latest digits during the sum
+      ! imod is not choosen to be very large as at the end there is a classic mpp_sum
+      imodd=65521 ! highest prime number < 2**16 with i8 type
+      imods=65521 ! highest prime number < 2**16 with default integer for mpp_sum subroutine
+      itmps=0
+      DO jj=nldj,nlej
+         DO ji=nldi,nlei
+            itmps = MOD(itmps + MOD(TRANSFER(pvar(ji,jj), ip),imodd), imods)
+         END DO
+      END DO
+      CALL mpp_sum('debug',itmps)
       !
-      CALL FLUSH(numout)
+      ! print out
+      IF (lwp) THEN
+         WRITE(numout,*) TRIM(cdtxt),' (min, max, sum, tag) : ',zmin, zmax, zsum, itmps
+         CALL FLUSH(numout)
+      END IF
       !
    END SUBROUTINE debug2d
@@ -77,23 +98,43 @@
       !!                  ***  ROUTINE isf_debug3d  ***
       !!
-      !! ** Purpose : add debug print
+      !! ** Purpose : add debug print for 3d variables
       !!
       !!-------------------------- IN  -------------------------------------
-      CHARACTER(LEN=256)              , INTENT(in   ) :: cdtxt
+      CHARACTER(LEN=*)                , INTENT(in   ) :: cdtxt
       REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in   ) :: pvar
       !!--------------------------------------------------------------------
       REAL(wp) :: zmin, zmax, zsum
+      INTEGER(i8) :: imodd, ip
+      INTEGER     :: itmps,imods, ji, jj, jk
       !!--------------------------------------------------------------------
       !
+      ! global min/max/sum to check data range and NaN
       zsum = glob_sum( 'debug', pvar(:,:,:) )
       zmin = glob_min( 'debug', pvar(:,:,:) )
       zmax = glob_max( 'debug', pvar(:,:,:) )
       !
-      IF (lwp) WRITE(numout,*) TRIM(cdtxt),' (min, max, sum) : ',zmin, zmax, zsum
+      ! basic check sum to check reproducibility
+      ! TRANSFER function find out the integer corresponding to pvar(i,j) bit pattern
+      ! MOD allow us to keep only the latest digits during the sum
+      ! imod is not choosen to be very large as at the end there is a classic mpp_sum
+      imodd=65521 ! highest prime number < 2**16 with i8 type
+      imods=65521 ! highest prime number < 2**16 with default integer for mpp_sum subroutine
+      itmps=0
+      DO jk=1,jpk
+         DO jj=nldj,nlej
+            DO ji=nldi,nlei
+               itmps = MOD(itmps + MOD(TRANSFER(pvar(ji,jj,jk), ip),imodd), imods)
+            END DO
+         END DO
+      END DO
+      CALL mpp_sum('debug',itmps)
       !
-      CALL FLUSH(numout)
+      ! print out
+      IF (lwp) THEN
+         WRITE(numout,*) TRIM(cdtxt),' (min, max, sum, tag) : ',zmin, zmax, zsum, itmps
+         CALL FLUSH(numout)
+      END IF
       !
    END SUBROUTINE debug3d
 
 END MODULE isfutils
-
Index: /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/LDF/ldfslp.F90
===================================================================
--- /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/LDF/ldfslp.F90	(revision 12076)
+++ /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/LDF/ldfslp.F90	(revision 12077)
@@ -21,5 +21,5 @@
    !!----------------------------------------------------------------------
    USE oce            ! ocean dynamics and tracers
-   USE isf            ! ice shelf
+   USE isf_oce        ! ice shelf
    USE dom_oce        ! ocean space and time domain
 !   USE ldfdyn         ! lateral diffusion: eddy viscosity coef.
Index: /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/LDF/ldftra.F90
===================================================================
--- /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/LDF/ldftra.F90	(revision 12076)
+++ /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/LDF/ldftra.F90	(revision 12077)
@@ -664,5 +664,5 @@
                   ! eddies using the isopycnal slopes calculated in ldfslp.F : 
                   ! T^-1 = sqrt(m_jpk(N^2*(r1^2+r2^2)*e3w))
-                  ze3w = e3w(ji,jj,jk,Kmm) * tmask(ji,jj,jk)
+                  ze3w = e3w(ji,jj,jk,Kmm) * wmask(ji,jj,jk)
                   zah(ji,jj) = zah(ji,jj) + zn2 * wslp2(ji,jj,jk) * ze3w
                   zhw(ji,jj) = zhw(ji,jj) + ze3w
@@ -682,5 +682,5 @@
                   ! eddies using the isopycnal slopes calculated in ldfslp.F : 
                   ! T^-1 = sqrt(m_jpk(N^2*(r1^2+r2^2)*e3w))
-                  ze3w = e3w(ji,jj,jk,Kmm) * tmask(ji,jj,jk)
+                  ze3w = e3w(ji,jj,jk,Kmm) * wmask(ji,jj,jk)
                   zah(ji,jj) = zah(ji,jj) + zn2 * ( wslpi(ji,jj,jk) * wslpi(ji,jj,jk)   &
                      &                            + wslpj(ji,jj,jk) * wslpj(ji,jj,jk) ) * ze3w
Index: /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/SBC/sbccpl.F90
===================================================================
--- /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/SBC/sbccpl.F90	(revision 12076)
+++ /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/SBC/sbccpl.F90	(revision 12077)
@@ -27,4 +27,5 @@
    USE sbcwave         ! surface boundary condition: waves
    USE phycst          ! physical constants
+   USE isf_oce , ONLY : l_isfoasis, fwfisf_oasis ! ice shelf boundary condition
 #if defined key_si3
    USE ice            ! ice variables
@@ -36,5 +37,4 @@
    USE eosbn2         ! 
    USE sbcrnf  , ONLY : l_rnfcpl
-   USE isf     , ONLY : ln_isf, l_isfoasis, fwfisf_oasis
 #if defined key_cice
    USE ice_domain_size, only: ncat
Index: /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/SBC/sbcfwb.F90
===================================================================
--- /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/SBC/sbcfwb.F90	(revision 12076)
+++ /NEMO/branches/2019/UKMO_MERGE_2019/src/OCE/SBC/sbcfwb.F90	(revision 12077)
@@ -17,8 +17,8 @@
    USE dom_oce        ! ocean space and time domain
    USE sbc_oce        ! surface ocean boundary condition
+   USE isf_oce , ONLY : fwfisf_cav, fwfisf_par                    ! ice shelf melting contribution
    USE sbc_ice , ONLY : snwice_mass, snwice_mass_b, snwice_fmass
    USE phycst         ! physical constants
    USE sbcrnf         ! ocean runoffs
-   USE isf            ! ice shelf melting contribution
    USE sbcssr         ! Sea-Surface damping terms
    !
